#!/usr/bin/env python
# -*- coding: utf-8 -*-

import random
import msglist
import webapp2
from google.appengine.api import urlfetch
from hashlib import sha1
from hmac import new as hmac
from random import getrandbits
from time import time
from urllib import urlencode
from urllib import quote as urlquote
from urllib import unquote as urlunquote


class TweetClient:
	consumer_key = '<change me>'
	consumer_secret = '<change me>'
	access_token = '<change me>'
	access_secret = '<change me>'
	url = 'https://api.twitter.com/1.1/statuses/update.json'
	
	def __init__(self, o):
		self.out = o
	
	def tweet(self,msg):
		def encode(text):
			return urlquote(str(text), "~")
			
		params = {
			"oauth_consumer_key": self.consumer_key,
			"oauth_signature_method": "HMAC-SHA1",
			"oauth_timestamp": str(int(time())),
			"oauth_nonce": str(getrandbits(64)),
			"oauth_version": "1.0",
			"oauth_token": self.access_token,
			"status": msg
		}
		for k,v in params.items():
			if isinstance(v, unicode):
				params[k] = v.encode('utf8')
		
		params_str = "&".join(["%s=%s" % (encode(k), encode(params[k]))
			for k in sorted(params)])
		
		message = "&".join(["POST", encode(self.url), encode(params_str)])
		key = "%s&%s" % (self.consumer_secret, self.access_secret) # Note compulsory "&".
		signature = hmac(key, message, sha1)
		digest_base64 = signature.digest().encode("base64").strip()
		params["oauth_signature"] = digest_base64
		payload = urlencode(params)
		
		return urlfetch.fetch(self.url,payload=payload,method=urlfetch.POST)

class MainHandler(webapp2.RequestHandler):
	def get(self, group1):
		tc = TweetClient(self.response.out)
		random.seed()
		
		msg =  msglist.list[random.randint(0,len(msglist.list)-1)]
		self.response.out.write("%s<br>\n" % (msg))
		res = tc.tweet(msg)
		self.response.out.write("[[%d]][[%s]][[%s]]" % (res.status_code,res.headers,res.content))
		

app = webapp2.WSGIApplication([('/tweet', MainHandler)],debug=True)
